using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Authenticaion.Commands.RevokeRefreshToken;

public class RevokeRefreshTokenCommandHandler :
    IRequestHandler<RevokeRefreshTokenCommand>
{
    private readonly AuthenticationService _authenticationService;

    public RevokeRefreshTokenCommandHandler(AuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task Handle(
        RevokeRefreshTokenCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RevokeRefreshTokenAsync(
            request.RefreshToken, cancellationToken);
    }
}
