using AutoMapper;
using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;

namespace cuqmbr.TravelGuide.Application.Common.Mappings.Resolvers;

public class DateTimeOffsetToLocalResolver : 
    IMemberValueResolver<object, object, DateTimeOffset, DateTimeOffset>
{
    private readonly TimeZoneService _timeZoneService;

    public DateTimeOffsetToLocalResolver(TimeZoneService timeZoneService)
    {
        _timeZoneService = timeZoneService;
    }

    public DateTimeOffset Resolve(
        object source, object destination,
        DateTimeOffset sourceMember, DateTimeOffset destinationMember,
        ResolutionContext context)
    {
        return TimeZoneInfo.ConvertTime(sourceMember, _timeZoneService.TimeZone);
    }
}
