using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.Regions;

public sealed class RegionDto : IMapFrom<Region>
{
    public Guid Uuid { get; set; }

    public string Name { get; set; }

    public Guid CountryUuid { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Region, RegionDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid))
            .ForMember(
                d => d.CountryUuid,
                opt => opt.MapFrom(s => s.Country.Guid));
    }
}
