using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Localization;
using cuqmbr.TravelGuide.Application.Common.Interfaces.Services;

namespace cuqmbr.TravelGuide.HttpApi.Controllers;

[Route("tests")]
public class TestsController : ControllerBase
{
    private readonly IStringLocalizer _localizer;

    public TestsController(
        CultureService cultureService,
        IStringLocalizer localizer)
    {
        _localizer = localizer;
    }

    [HttpGet("getLocalizedString/{inputString}")]
    public Task<string> getLocalizedString(
        [FromRoute] string inputString,
        CancellationToken cancellationToken)
    {
        return Task.FromResult<string>(_localizer[inputString]);
    }
}
