using cuqmbr.TravelGuide.Identity.Models;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace cuqmbr.TravelGuide.Identity.Persistence.PostgreSql.Configurations;

public class IdentityRoleConfiguration : IEntityTypeConfiguration<IdentityRole>
{
    public void Configure(EntityTypeBuilder<IdentityRole> builder)
    {
        builder
            .ToTable("roles");

        builder
            .Property(r => r.Id)
            .HasColumnName("id");

        builder
            .Property(r => r.Uuid)
            .HasColumnName("uuid");

        builder
            .Property(r => r.Name)
            .HasColumnName("name");

        builder
            .Property(r => r.NormalizedName)
            .HasColumnName("normalized_name");

        builder
            .Property(r => r.ConcurrencyStamp)
            .HasColumnName("concurrency_stamp");
    }
}
