using System.Reflection;
// using cuqmbr.TravelGuide.Domain.Enums;
using Microsoft.EntityFrameworkCore;
// using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace cuqmbr.TravelGuide.Persistence.InMemory;

public class InMemoryDbContext : DbContext
{
    public InMemoryDbContext(DbContextOptions<InMemoryDbContext> options)
        : base(options) { }

    protected override void OnModelCreating(ModelBuilder builder)
    {
        base.OnModelCreating(builder);

        // builder.HasPostgresEnum(
        //     "vehicle_type",
        //     VehicleType.Enumerations.Select(e => e.Value.Name).ToArray());
        //
        builder
            .ApplyConfigurationsFromAssembly(
                Assembly.GetExecutingAssembly(),
                t => t.Namespace ==
                    "cuqmbr.TravelGuide.Persistence.InMemory.Configurations");
    }

    protected override void ConfigureConventions(
        ModelConfigurationBuilder builder)
    {
        // builder
        //     .Properties<VehicleType>()
        //     .HaveColumnType("vehicle_type")
        //     .HaveConversion<VehicleTypeConverter>();
    }
}

// public class VehicleTypeConverter : ValueConverter<VehicleType, string>
// {
//     public VehicleTypeConverter() 
//         : base(
//         v => v.Name,
//         v => VehicleType.FromName(v))
//     { }
// }
