﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using cuqmbr.TravelGuide.Persistence.PostgreSql;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    [DbContext(typeof(PostgreSqlDbContext))]
    [Migration("20250427160059_Initial_migration")]
    partial class Initial_migration
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasDefaultSchema("application")
                .HasAnnotation("ProductVersion", "9.0.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.HasPostgresEnum(modelBuilder, "vehicle_type", new[] { "bus", "train", "aircraft" });
            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.HasSequence("addresses_id_sequence");

            modelBuilder.HasSequence("cities_id_sequence");

            modelBuilder.HasSequence("countries_id_sequence");

            modelBuilder.HasSequence("regions_id_sequence");

            modelBuilder.HasSequence("route_addresses_id_sequence");

            modelBuilder.HasSequence("routes_id_sequence");

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.addresses_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "addresses_id_sequence");

                    b.Property<long>("CityId")
                        .HasColumnType("bigint")
                        .HasColumnName("city_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(128)")
                        .HasColumnName("name");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("application.vehicle_type")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_addresses");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_addresses_Guid");

                    b.HasIndex("CityId")
                        .IsUnique()
                        .HasDatabaseName("ix_addresses_city_id");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_addresses_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_addresses_id");

                    b.ToTable("addresses", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.cities_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "cities_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.Property<long>("RegionId")
                        .HasColumnType("bigint")
                        .HasColumnName("region_id");

                    b.HasKey("Id")
                        .HasName("pk_cities");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_cities_Guid");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_cities_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_cities_id");

                    b.HasIndex("RegionId")
                        .IsUnique()
                        .HasDatabaseName("ix_cities_region_id");

                    b.ToTable("cities", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.countries_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "countries_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_countries");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_countries_Guid");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_countries_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_countries_id");

                    b.ToTable("countries", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.regions_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "regions_id_sequence");

                    b.Property<long>("CountryId")
                        .HasColumnType("bigint")
                        .HasColumnName("country_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_regions");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_regions_Guid");

                    b.HasIndex("CountryId");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_regions_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_regions_id");

                    b.ToTable("regions", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Route", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.routes_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "routes_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("application.vehicle_type")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_routes");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_routes_Guid");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_routes_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_routes_id");

                    b.ToTable("routes", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.route_addresses_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "route_addresses_id_sequence");

                    b.Property<long>("AddressId")
                        .HasColumnType("bigint")
                        .HasColumnName("address_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<short>("Order")
                        .HasColumnType("smallint")
                        .HasColumnName("order");

                    b.Property<long>("RouteId")
                        .HasColumnType("bigint")
                        .HasColumnName("route_id");

                    b.HasKey("Id")
                        .HasName("pk_route_addresses");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_route_addresses_Guid");

                    b.HasAlternateKey("AddressId", "RouteId", "Order")
                        .HasName("altk_route_addresses_address_id_route_id_order");

                    b.HasIndex("AddressId")
                        .IsUnique()
                        .HasDatabaseName("ix_route_addresses_address_id");

                    b.HasIndex("Guid")
                        .IsUnique()
                        .HasDatabaseName("ix_route_addresses_uuid");

                    b.HasIndex("Id")
                        .IsUnique()
                        .HasDatabaseName("ix_route_addresses_id");

                    b.HasIndex("RouteId")
                        .IsUnique()
                        .HasDatabaseName("ix_route_addresses_route_id");

                    b.ToTable("route_addresses", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.City", "City")
                        .WithMany("Addresses")
                        .HasForeignKey("CityId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_addresses_city_id");

                    b.Navigation("City");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Region", "Region")
                        .WithMany("Cities")
                        .HasForeignKey("RegionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_cities_region_id");

                    b.Navigation("Region");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Country", "Country")
                        .WithMany("Regions")
                        .HasForeignKey("CountryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_regions_country_id");

                    b.Navigation("Country");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Address", "Address")
                        .WithMany("AddressRoutes")
                        .HasForeignKey("AddressId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_addresses_address_id");

                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Route", "Route")
                        .WithMany("RouteAddresses")
                        .HasForeignKey("RouteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_addresses_route_id");

                    b.Navigation("Address");

                    b.Navigation("Route");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.Navigation("AddressRoutes");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Navigation("Regions");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Navigation("Cities");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Route", b =>
                {
                    b.Navigation("RouteAddresses");
                });
#pragma warning restore 612, 618
        }
    }
}
