using Microsoft.EntityFrameworkCore;

namespace cuqmbr.TravelGuide.Persistence.PostgreSql;

public static class PostgreSqlDbInitializer
{
    public static void Initialize(PostgreSqlDbContext dbContext)
    {
        var totalMigrationsCount = 
            dbContext.Database.GetMigrations().Count();
        var appliedMigrationCount = 
            dbContext.Database.GetAppliedMigrations().Count();

        if (totalMigrationsCount - appliedMigrationCount > 0)
        {
            dbContext.Database.Migrate();
        }

        dbContext.Dispose();
    }
}
